Option Strict Off
Option Explicit On
Imports VB = Microsoft.VisualBasic
'Imports System
'Imports system.threading
'Imports System.Windows.Forms
'Imports System.ComponentModel

Friend Class frmMain
    Inherits System.Windows.Forms.Form

    Public Baud As Short
    Public ComPort As String
    Public IDin As String
    Public DLCin As Short
    Public NoLogging As Short
    Public TextIn As String
    Dim DataIn(8) As String
    Dim IDout As String
    Dim DLCout As Short
    Dim DataOut(8) As String
    Dim Connect As Short
    Dim Counter531 As Short
    Dim DataToFile As String
    Public WithEvents Serialport As New IO.Ports.SerialPort
    Delegate Sub SetTextCallback(ByVal [text] As String)



    Private Sub cmdConnect_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdConnect.Click
        'On Error GoTo Errorhandler
        If Connect = 0 Then
            Try
                With Serialport
                    .PortName = frmSettings.cmbComPort.Text
                    .BaudRate = 115000
                    .Parity = IO.Ports.Parity.None
                    .DataBits = 8
                    .StopBits = IO.Ports.StopBits.One
                End With
                Serialport.Open()
                ComPort = Serialport.PortName
                cmdConnect.Text = "Disconnect"
                Connect = 1
                sbrStatusPort.Text = ComPort & " : Open"
                sbrStatus.Text = ComPort & " : Open"
                Serialport.Write("C" & vbCr)
                If frmSettings.optBaud2.Checked = True Then
                    Serialport.Write("S3" & vbCr)
                Else
                    Serialport.Write("s" & frmSettings.txtBRG1.Text & frmSettings.txtBRG2.Text & frmSettings.txtBRG3.Text & vbCr)
                End If
                Serialport.Write("O" & vbCr)
            Catch ex As Exception
                MsgBox(ex.ToString)
            End Try
        Else
            Serialport.Close()
            cmdConnect.Text = "Connect"
            Connect = 0
            sbrStatus.Text = ComPort & " : Closed"
            sbrStatusPort.Text = ComPort & " : Closed"
        End If
        Exit Sub


    End Sub

    Private Sub cmdLogging_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdLogging.Click

        If cmdLogging.Text = "Start Logging" Then
            If frmSettings.txtDataFile.Text = "" Then
                frmSettings.GetFile()
                If NoLogging = 0 Then
                    frmSettings.StartLogging()
                    cmdLogging.Text = "Stop Logging"
                End If
            Else
                frmSettings.StartLogging()
                cmdLogging.Text = "Stop Logging"
            End If
        Else
            'UPGRADE_WARNING: Couldn't resolve default property of object frmSettings.DataFile.Close. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
            frmSettings.DataFile.Close()
            cmdLogging.Text = "Start Logging"
            NoLogging = 1
        End If
    End Sub

    Private Sub DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles Serialport.DataReceived

        AddHandler Serialport.DataReceived, AddressOf OnDataReceived
        
    End Sub

   Private Sub OnDataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs)
        Dim port As System.IO.Ports.SerialPort = CType(sender, System.IO.Ports.SerialPort)
        Dim TextTemp As String = port.ReadExisting
        Dim i As Short
        Dim test As String

        If TextTemp <> "" Then
            test = Asc(TextTemp)
            TextIn = TextTemp
            While Mid(TextIn, 1, 1) = vbCr
                TextIn = Mid(TextIn, 2, Len(TextIn) - 1)
            End While
            If TextIn <> "" Then
                DataToFile = ""
                IDin = Mid(TextIn, 2, 3)
                DLCin = Mid(TextIn, 5, 1)
                DataToFile = IDin & vbTab & DLCin & vbTab
                If Val(CStr(DLCin)) > 0 Then
                    For i = 1 To DLCin
                        DataIn(i) = Mid(TextIn, 4 + i * 2, 2)
                        DataToFile = DataToFile & DataIn(i) & " "
                    Next i
                End If
                'Console.Write("TextIn  " & TextIn)
                Me.SetText(IDin & "  " & DLCin & "  ")
                If Val(CStr(DLCin)) > 0 Then
                    For i = 1 To DLCin
                        Me.SetText(DataIn(i) & " ")
                        DataIn(i) = ""
                    Next i
                End If
                Me.SetText(vbCrLf)
                'UPGRADE_WARNING: Couldn't resolve default property of object frmSettings.DataFile.writeline. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
                If NoLogging = 0 Then frmSettings.DataFile.writeline(DataToFile)
                TextIn = ""
                Check()
                IDin = ""
                DLCin = 0
            End If
        End If
    End Sub

    Private Sub SetText(ByVal [text] As String)
        If Me.txtData.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf SetText)
            Me.Invoke(d, New Object() {[text]})
        Else
            Me.txtData.Text = Me.txtData.Text & [text]
        End If
    End Sub
    Private Sub frmMain_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load

        frmSettings.cmbComPort.Items.Clear()
        For i As Integer = 0 To _
                 My.Computer.Ports.SerialPortNames.Count - 1
            frmSettings.cmbComPort.Items.Add( _
               My.Computer.Ports.SerialPortNames(i))
        Next
        frmSettings.cmbComPort.SelectedIndex = 0
        Connect = 0
        ComPort = frmSettings.cmbComPort.Text
        NoLogging = 1
    End Sub

    Public Sub mnuExit_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuExit.Click
        If Serialport.IsOpen Then Serialport.Close()
        Me.Close()
    End Sub

    Public Sub mnuSettings_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuSettings.Click
        frmSettings.Show()
    End Sub

    Private Sub tmrOut439_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles tmrOut439.Tick
        tmrOut439.Enabled = False
        Me.SetText("Tmr439")
        SendData()
        If Counter531 = 0 Then
            tmrOut439.Interval = 4
            tmrOut439.Enabled = True
            Counter531 = 1
        End If
    End Sub

    Private Sub tmrOut661_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles tmrOut661.Tick
        tmrOut661.Enabled = False
        Me.SetText("Tmr661")
        SendData()
    End Sub

    Private Sub tmrStatus_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles tmrStatus.Tick
        sbrStatus.Items.Item("Status").Text = "Status: "
        tmrStatus.Enabled = False

    End Sub

    Private Sub Check()

        If IDin = "439" Then
            IDout = "531"
            DLCout = 4
            DataOut(1) = "C3"
            DataOut(2) = "20"
            DataOut(3) = "30"
            DataOut(4) = "D3"
            tmrOut439.Interval = 38
            tmrOut439.Enabled = True
            Counter531 = 0
        End If

        If IDin = "661" Then
            IDout = "470"
            DLCout = 5
            DataOut(1) = "80"
            DataOut(2) = "00"
            DataOut(3) = "40"
            DataOut(4) = "00"
            DataOut(5) = "00"
            tmrOut661.Interval = 14
            tmrOut661.Enabled = True
        End If

    End Sub

    Private Sub SendData()

        Dim TempData As String
        Dim i As Short

        DataToFile = IDout & vbTab & DLCout & vbTab
        TempData = "t" & IDout & DLCout
        For i = 1 To DLCout
            TempData = TempData & DataOut(i)
            DataToFile = DataToFile & DataOut(i) & " "
            If Counter531 = 1 Then DataOut(i) = ""
        Next i
        TempData = TempData & vbCr
        'UPGRADE_WARNING: Couldn't resolve default property of object frmSettings.DataFile.writeline. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
        'If NoLogging = 0 Then frmSettings.DataFile.writeline(DataToFile)
        Serialport.Write(TempData)
        If Counter531 = 1 Then
            IDout = ""
            DLCout = 0
        End If

    End Sub

    
End Class